%% ------------------------------------------------------------------------- %% \\
\chapter{Path into Linux kernel Community}
\label{att:contribDRM}

\section{Changing to Another Subsystem - Development Environment Setup}

My first barrier to become a member of the DRI community was setting up the
development
environment\footnote{\url{https://melissawen.github.io/blog/2020/01/08/hello-drm}}
and find how to contribute considering my lack of understanding of the
subsystem functions and the necessary abstractions of graphic concepts.

I started to get involved in the community by exploring the subsystems drives
and sending small
contributions\footnote{\url{https://melissawen.github.io/blog/2020/03/04/first-patch-drm}}.
As I had already contributed to improving code style and cleanup checkpatch
warnings, I chose a bug-fix issue to work on. I tried to reproduce the reported
bug and looked for community guidance, but I was not successful\footnote{\url{https://www.spinics.net/lists/dri-devel/msg248102.html}}.
\textit{In this first experience, I realized that neither maintainers nor active
developers know everything on a subsystem.} Consequently, considering my
initial limitations, I went back to work on code style issues to keep engaged
and find some mentorship.

\subsection{Role: Google Summer Of Code Applicant}

In a subsequent step of participant-observation, I decided to apply to the
X.Org Foundation project on Google Summer of Code
Program\footnote{\url{https://summerofcode.withgoogle.com/}}.  The application
step consists of proposing a project based on the list of ideas suggested by
community mentors of X.Org Foundation.  In this program, mentors are active
community developers that volunteer to guide new developers to accomplish their
project goals.  Graphic developers usually need hardware display capability to
develop features and improvements. For this reason, I opted to work on
VKMS\footnote{\url{https://dri.freedesktop.org/docs/drm/gpu/vkms.html}}, a
software-only model KMS driver developed to run and test DRM and X in a
headless machine.

To figure out how to fix a bug on VKMS, I used a test suite originally
developed by Intel, the IGT GPU
Tools\footnote{\url{https://gitlab.freedesktop.org/drm/igt-gpu-tools}}.  By
checking how to fix a test case failure, I obtained an overview of the test
coverage.  I mapped the results of each test case and realized that the driver
was presenting an unexpected behavior that cross-cut
testing\footnote{\url{https://melissawen.github.io/blog/2020/03/23/a-tangle-issues}}.
Therefore, I design a GSoC project to improve VKMS using IGT GPU Tools.

In one of my attempts to fix a bug on the VKMS driver, my patch received a
review criticizing the proposed
solution\footnote{\url{https://www.spinics.net/lists/kernel/msg3450967.html}}.
The reviewer proposed a better code to solve the issue, but I considered the
message was rude and
discouraging\footnote{\url{https://melissawen.github.io/blog/2020/03/23/good-bad}}.
Initially, I thought the person was a DRI community member.  However, after one
year in the community, I can say this person is completely out of the usual
Linux DRI more active developer. Maybe this developer came from another
subsystem because I copied the Linux kernel mailing list.

\subsubsection{Contributions sent to DRM subsystem for GSoC application}

\begin{table}[h]
\centering
\resizebox{\textwidth}{!}{\begin{tabular}{  | m{2.5cm} | m{6cm} | m{2.5cm} | m{3cm} | m{2cm} | m{2cm} |  }
\hline
\textbf{1st Version Date} & \textbf{Commit message} & \textbf{Developer(s)} & \textbf{Kind of change} & \textbf{\# Versions} & \textbf{Status} \\ \hline
Feb. 26, 2020 & drm/amd/display: dc\_link: code clean up on enable\_link\_dp function & Melissa Wen & Code style & 2 & Merged \\ \hline
Feb. 26, 2020 & drm/amd/display: dc\_link: code clean up on detect\_dp function      & Melissa Wen & Code style & 2 & Merged \\ \hline
Mar. 2, 2020 & drm/amd/display: dcn20: remove an unused function                   & Melissa Wen & Improve maintanability & 1 & Merged \\ \hline
Mar. 21, 2020 & drm/vkms: use bitfield op to get xrgb on compute crc               & Melissa Wen & Bug-fix & 1 & Declined \\ \hline
March 21, 2020 & drm/vkms: enable cursor by default                                & Melissa Wen & Improve usability & 2 & Merged \\ \hline
March 31, 2020 & drm/amd/display: cleanup codestyle type BLOCK\_COMMENT\_STYLE on dc\_link       & Melissa Wen & Code style & 2 & Merged \\ \hline
March 31, 2020 & drm/amd/display: codestyle cleanup on dc\_link file until detect\_dp func       & Melissa Wen & Code style & 2 & Merged \\ \hline
March 31, 2020 & drm/amd/display: code cleanup on dc\_link from is\_same\_edid to get\_ddc\_line & Melissa Wen & Code style & 2 & Merged \\ \hline
March 31, 2020 & drm/amd/display: code cleanup of dc\_link file on func dc\_link\_construct      & Melissa Wen & Code style & 2 & Merged \\ \hline
\end{tabular}%
}%
\caption{Contributions sent to DRM subsystem for GSoC application}
\label{tab:list_pregsoc}
\end{table}

\subsection{Role: GSoC Intern}

My project was the unique X.Org Foundation project
accepted\footnote{\url{https://summerofcode.withgoogle.com/archive/2020/projects/6046648674811904/}}
in 2020 GSoC.  This participation was hands-on, with technical issues and
community engagement experience.  I reported the steps in the learning curve
and project acquaintance in 12 blog posts:

\begin{table}[]
\centering
\resizebox{\textwidth}{!}{%
\begin{tabular}{|l|l|l|}
\hline
Date & Title & Link \\ \hline
2020/05/13 & I’m in - GSoC 2020 - X.Org Foundation & \url{https://melissawen.github.io/blog/2020/05/13/im-in-gsoc} \\ \hline
2020/05/20 & Everyone makes a script & \url{https://melissawen.github.io/blog/2020/05/20/community-bounding} \\ \hline
2020/06/02 & Status update - Tie up loose ends before starting & \url{https://melissawen.github.io/blog/2020/06/02/status-update} \\ \hline
2020/06/03 & Walking in the KMS CURSOR CRC test & \url{https://melissawen.github.io/blog/2020/06/03/overview\_kms\_cursor\_crc} \\ \hline
2020/06/15 & Status update - connected errors & \url{https://melissawen.github.io/blog/2020/06/15/status-update} \\ \hline
2020/07/06 & GSoC First Phase - Achievements & \url{https://melissawen.github.io/blog/2020/07/06/first-round} \\ \hline
2020/07/17 & Increasing test coverage in VKMS - max square cursor size & \url{https://melissawen.github.io/blog/2020/07/17/add-max-cursor-size.html} \\ \hline
2020/08/12 & The end of an endless debugging of an endless wait & \url{https://melissawen.github.io/blog/2020/08/12/end\_of\_endless.html} \\ \hline
2020/08/19 & If a warning remains, the job is not finished. & \url{https://melissawen.github.io/blog/2020/08/19/let-vkms-blend-it.html} \\ \hline
2020/08/27 & Another day, another mistery & \url{https://melissawen.github.io/blog/2020/08/27/writeback-is-back} \\ \hline
2020/08/28 & Better validation of alpha-blending & \url{https://melissawen.github.io/blog/2020/08/28/translucent-cursor-testcase} \\ \hline
2020/08/31 & GSoC Final Report & \url{https://melissawen.github.io/blog/2020/08/31/gsoc-final-report} \\ \hline
\end{tabular}%
}
\caption{blog\_posts}
\label{tab:slr_papers}
\end{table}

The experience of blogging and sharing the content in the
Freedesktop\footnote{\url{https://planet.freedesktop.org/}} and
Debian\footnote{\url{https://planet.debian.org/}} Planet brought me even closer
to the community. I received positive feedback on \#dri-devel channel (IRC),
and it was a way to get known to other developers of the community that works
for different worldwide companies.  However, I did not share every thought
there because I worried with the audience.  During the project, an outsider
started to work on the same things that I had scheduled for my project.
Initially, I decided to share knowledge in a discussion between this newcomer
and a subsystem maintainer.  We started a thought-building process, looking for
the proper solution. However, at some point, I felt the person stole my
proposed solution when I suddenly saw that solution in a patch with no mention
of my authorship or co-development. After sharing this episode with others, I
realized that sometimes two people do not know they are working on the same
solution, and it is acceptable. However, it is not uncommon for someone to ``
steal '' a patch in development by another.  Respecting the work of others is a
good community practice. A developer can use tags to grant credits when more
than one works on a solution.  The Linux kernel documentation describes the
standards
tags\footnote{\url{https://www.kernel.org/doc/html/latest/process/submitting-patches.html\#when-to-use-acked-by-cc-and-co-developed-by}}.

\subsubsection{Contributions for VKMS driver / DRM subsystem}

\begin{table}[h]
\centering
\resizebox{\textwidth}{!}{\begin{tabular}{  | m{2.5cm} | m{6cm} | m{2.5cm} | m{3cm} | m{2cm} | m{2cm} |  }
\hline
\textbf{1st Version Date} & \textbf{Commit message} & \textbf{Developer(s)} & \textbf{Kind of change} & \textbf{\# Versions} & \textbf{Status} \\ \hline
July 10, 2020 & drm/vkms: change the max cursor width/height & Melissa Wen & Increase test coverage & 1 & Merged \\ \hline
July 14, 2020 & drm/vkms: add wait\_for\_vblanks in atomic\_commit\_tail & Melissa Wen & Fix operational behavior & 1 & Declined \\ \hline
July 22, 2020 & drm/vkms: add missing drm\_crtc\_vblank\_put to the get/put pair on flush & Melissa Wen & Fix operational behavior & 1 & Declined \\ \hline
July 30, 2020 & drm/vkms: fix xrgb on compute crc & Melissa Wen & Bug-fix & 1 & Merged \\ \hline
Aug. 1, 2020 & drm/vkms: guarantee vblank when capturing crc & Melissa Wen & Fix operating behavior & 3 & Merged \\ \hline
Aug. 19, 2020 & drm/vkms: add alpha-premultiplied color blending & Melissa Wen & Add new feature & 2 & Merged \\ \hline
\end{tabular}%
}
\caption{Contributions sent to DRM subsystem during GSoC project}
\label{tab:list_gsoc_drm}
\end{table}

\subsubsection{Contributions for IGT GPU tools}

\begin{table}[h]
\centering
\resizebox{\textwidth}{!}{\begin{tabular}{  | m{2.5cm} | m{6cm} | m{2.5cm} | m{3cm} | m{2cm} | m{2cm} |  }
\hline
\textbf{1st Version Date} & \textbf{Commit message} & \textbf{Developer(s)} & \textbf{Kind of change} & \textbf{\# Versions} & \textbf{Status} \\ \hline
June 25, 2020 & test/kms\_cursor\_crc: release old pipe\_crc before create a new one & Melissa Wen & Bug-fix & 2 & Merged \\ \hline
June 25, 2020 & lib/igt\_fb: change comments with fd description & Melissa Wen & Improve Maintainability & 2 & Merged \\ \hline
June 25, 2020 & test/kms\_cursor\_crc: update subtests descriptions and some comments & Melissa Wen & Documentation & 2 & Merged \\ \hline
July 6, 2020 & lib/igt\_fb: remove extra parameters from igt\_put\_cairo\_ctx & Melissa Wen & Improve Maintainability & 1 & Merged \\ \hline
Aug. 26, 2020 & tests/kms\_cursor\_crc: refactoring cursor-alpha subtests & Melissa Wen & New feature & 2 & Any \\ \hline
\end{tabular}%
}
\caption{Contributions sent to IGT GPU Tools project during GSoC}
\label{tab:list_gsoc_igt}
\end{table}

\subsection{Role: Independent Linux kernel developer}

The Linux DRM subsystem has a very active community on IRC. Comparing with the
IIO subsystem, the DRI community is larger. While the \#dri-devel channel never
stops to receive messages, no single message arrives in \#linux-iio. Graphic
developers use the IRC to ask for technical advice, patch review or acks,
synchronize maintainership work, and discuss the use of tools and processor to
share knowledge.

\begin{table}[h]
\centering
\resizebox{\textwidth}{!}{\begin{tabular}{  | m{2.5cm} | m{6cm} | m{5cm} |  }
\hline
\textbf{Last Version Date} & \textbf{Commit message} & \textbf{Developer(s)} \\ \hline
Jan. 21, 2021 & drm/vkms: Annotate vblank timer & Daniel Vetter \\ \hline
Jan. 01, 2021 & drm/vkms: Decouple config data for configfs & Sumera Priyadarsini and Daniel Vetter\\ \hline
Oct. 13, 2020 & drm/vkms: Switch to shmem helpers & Daniel Vetter \\ \hline
Oct. 09, 2020 & drm/vkms: fbdev emulation support & Daniel Vetter \\ \hline
Oct. 06, 2020 & drm/vkms: update todo & Melissa Wen \\ \hline
Sep. 27, 2020 & drm/vgem: validate vgem\_device before exit operations & Melissa Wen \\ \hline
Sep. 23, 2020 & drm/vkms: Introduce GEM object functions & Thomas Zimmermann \\ \hline
Sep. 23, 2020 & drm/vgem: Introduce GEM object functions & Thomas Zimmermann \\ \hline
Aug. 30, 2020 & drm/vkms: Introduces writeback support & Rodrigo Siqueira \\ \hline
Aug. 27, 2020 & drm/vkms: avoid warning in vkms\_get\_vblank\_timestamp & Sidong Yang \\ \hline
\end{tabular}%
}
\caption{Contributions to DRM - Coding, Reviewing and Testing}
\label{tab:list_developer}
\end{table}

\subsection{Role: VKMS Driver maintainer}

Graphic maintainers on the DRM subsystem should follow a workflow to apply
patches in the subsystem repository.  \textit{``The tools and workflows for
maintaining and contributing to the Linux kernel DRM subsystem's drm-misc and
drm-intel repositories} are documented and available publicly on
\url{https://drm.pages.freedesktop.org/maintainer-tools/index.html} Any DRM
community member, even more, maintainer should follow the freedesktop.org and
kernel.org Code of Conduct.

\textit{``Abuse of commit rights, like engaging in commit fights or willfully
pushing patches that violate the documented merge criteria or process, will
also be handled through the Code of Conduct enforcement process. Violations may
lead to temporary or permanent account or commit rights suspension according to
freedesktop.org umbrella rules.''} Also, driver maintainers should be attentive
to the mailing-list and inbox to catch contributions, questions, and code
changes that affect the related driver.

\subsection{Role: Co-mentor for Internship program}

In this cycle, I co-mentored an intern in the Linux kernel community for the
Outreachy Program.  \textit{``Outreachy provides remote internships. Outreachy
internships are open to applicants around the world. Interns work remotely.
Interns are not required to move. Interns work with experienced mentors from
open source communities. Outreachy internship projects may include programming,
user experience, documentation, illustration, graphical design,  data science,
project marketing, user advocacy, or community event planning. Outreachy's goal
is to increase diversity in open
source.''}\footnote{\url{https://www.outreachy.org/}}

The program has two phases: the application period and the internship period.
Pre-selected applicants start to contribute to the community they want to work
in the internship in the application period.  \textit{``Prospective interns
(applicants) work with mentors to complete small contributions to the project
during the six-week application period.''} If selected, interns work for three
months to develop the internship project. Besides the internship project
development, interns should participate in biweekly chats and write posts in a
blog sharing their program experience. The program timeline details the
tasks\footnote{\url{https://www.outreachy.org/docs/internship/}}.

As a mentor, I also have responsibilities and time commitment in both
phases\footnote{\url{https://www.outreachy.org/mentor/\#mentor}}.  The
application phase gave me some interesting insights on newcomers.

\begin{enumerate}
		\item For the Linux kernel project, applicants should start to
			set up the development environment and get familiar
			with the submitting patch steps before the application
			period starts. Applicants who started to figure out how
			to contribute to the Linux kernel community only when
			in the application period seemed to face barriers hard
			to overcome in the timebox of six-week. For the project
			that I mentored, three expressed interest, one gave up
			without any submission, one did not have enough time to
			build the project schedule, and only one was accepted.
		\item The community members start to observe negative behavior
			even in the application phase. As the intern will work
			together with the community, good social skills and
			respecting others' work make a difference to be or not
			selected. I experienced some occurrence of ``social
			faults'', I saw the community coordinator's reaction
			and captured the opinion of other community members
			regarding the episode. For some long-term developers,
			certain behaviors show disengagement from the project,
			which conflicts with mentoring motivation.
		\item The kernel community advises applicants to add a prefix
			on patches related to the Outreachy program. Therefore,
			community members can identify the contributions of
			newcomers from this program. It may help to avoid rude
			comments and do not happens in the Google Summer of
			Code program.
		\item In this phase, we try to evaluate the ability to design a
			good project, engagement, self-commitment, and
			communication in more than technical skills.
\end{enumerate}

The benefits of mentoring an intern are twofold: recruitment of new developers
to the community and updating and strengthening subsystem knowledge.  This
experience exposes that even long-term experienced developers and maintainers
do not know everything under their maintainership.  Also, the Linux kernel
solutions are collaborative work that requires developers with different
expertise and backgrounds.  Maintainers have responsibilities as a team leader:
clerical tasks, development and people management, reviewing contributions, and
connecting people.
